From ea0f129c606e43734b5c8ce04b0d666a4d8ce842 Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Mon, 1 Feb 2021 14:24:25 +0300
Subject: [PATCH 45/59] AlpineApkUpdater: fix progress reporting for system
 upgrade

Connect to progress updates from helper and implement
AlpineApkUpdater::progress() getter function.
---
 .../AlpineApkBackend/AlpineApkUpdater.cpp     | 23 +++++++++++++++----
 .../AlpineApkBackend/AlpineApkUpdater.h       |  3 ++-
 2 files changed, 21 insertions(+), 5 deletions(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp
index 0bbbce1c0..30399369b 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp
@@ -91,8 +91,7 @@ bool AlpineApkUpdater::hasUpdates() const
 
 qreal AlpineApkUpdater::progress() const
 {
-    qCDebug(LOG_ALPINEAPK) << Q_FUNC_INFO;
-    return 0.0;
+    return m_upgradeProgress;
 }
 
 void AlpineApkUpdater::removeResources(const QList<AbstractResource *> &apps)
@@ -171,10 +170,15 @@ void AlpineApkUpdater::start()
     // run upgrade with elevated privileges
     KAuth::ExecuteJob *reply = ActionFactory::createUpgradeAction();
     if (!reply) return;
+
     QObject::connect(reply, &KAuth::ExecuteJob::result,
                      this, &AlpineApkUpdater::handleKAuthUpgradeHelperReply);
+    // qOverload is needed because of conflict with getter named percent()
+    QObject::connect(reply, QOverload<KJob *, unsigned long>::of(&KAuth::ExecuteJob::percent),
+                     this, &AlpineApkUpdater::handleKAuthUpgradeHelperProgress);
 
     m_progressing = true;
+    m_upgradeProgress = 0.0;
     Q_EMIT progressingChanged(m_progressing);
 
     reply->start();
@@ -239,6 +243,17 @@ void AlpineApkUpdater::handleKAuthUpdateHelperProgress(KJob *job, unsigned long
     Q_EMIT progressChanged(static_cast<qreal>(percent));
 }
 
+void AlpineApkUpdater::handleKAuthUpgradeHelperProgress(KJob *job, unsigned long percent)
+{
+    Q_UNUSED(job)
+    qCDebug(LOG_ALPINEAPK) << "    upgrade progress: " << percent;
+    qreal newProgress = static_cast<qreal>(percent);
+    if (newProgress != m_upgradeProgress) {
+        m_upgradeProgress = newProgress;
+        Q_EMIT progressChanged(m_upgradeProgress);
+    }
+}
+
 void AlpineApkUpdater::handleKAuthUpgradeHelperReply(KJob *job)
 {
     KAuth::ExecuteJob *reply = static_cast<KAuth::ExecuteJob *>(job);
@@ -258,8 +273,8 @@ void AlpineApkUpdater::handleKAuthUpgradeHelperReply(KJob *job)
         handleKAuthHelperError(reply, replyData);
     }
 
-    // we are not in the state "Fetching updates" now, update UI
-    Q_EMIT checkForUpdatesFinished();
+    m_progressing = false;
+    Q_EMIT progressingChanged(m_progressing);
 }
 
 void AlpineApkUpdater::handleKAuthHelperError(
diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.h b/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.h
index 0ee2fcb47..6ca3ce073 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.h
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.h
@@ -159,6 +159,7 @@ public Q_SLOTS:
     void handleKAuthUpdateHelperProgress(KJob *job, unsigned long percent);
     // upgrade
     void handleKAuthUpgradeHelperReply(KJob *job);
+    void handleKAuthUpgradeHelperProgress(KJob *job, unsigned long percent);
 
     //void transactionRemoved(Transaction* t);
     //void cleanup();
@@ -186,7 +187,7 @@ private:
 //    QSet<AbstractResource*> m_upgradeable;
 //    QSet<AbstractResource*> m_pendingResources;
     bool m_progressing = false;
-//    qreal m_progress;
+    qreal m_upgradeProgress = 0.0;
 //    QDateTime m_lastUpdate;
 //    QTimer m_timer;
 //    bool m_canCancel = false;
-- 
GitLab


